;################################################################################
;#										#
;# libmio - multi i/o for ATMega 644						#
;# macro definitions								#
;# copyright (c) 2005-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libmio_vint
    rjmp	libmio_aisr
.endm

.macro libmio_bint
    rjmp	libmio_bisr
.endm

.macro libmio_init
    rcall	libmio_init
.endm

.macro libmio_outchar
    rcall	libmio_char
.endm

.macro libmio_outcomma
    rcall	libmio_comma
.endm

.macro libmio_outspace
    rcall	libmio_space
.endm

.macro libmio_waitkey
    .set	use_libmio_waitkey = 1
    .set	libmio_ps2key = 1
    rcall	libmio_waitkey
.endm

.macro libmio_nokey
    .set	use_libmio_nokey = 1
    .set	libmio_ps2key = 1
    rcall	libmio_nokey
.endm

.macro libmio_cursor
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    rcall	libmio_cursor
.endm

.macro libmio_ecursor
    .set	use_libmio_ecursor = 1
    .set	use_libmio_editor_mode = 1
    .set	libmio_ps2key = 1
    rcall	libmio_ecursor
.endm

.macro libmio_ncursor
    .set	use_libmio_ncursor = 1
    .set	use_libmio_editor_mode = 1
    .set	libmio_ps2key = 1
    rcall	libmio_ncursor
.endm

.macro libmio_freecur
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    rcall	libmio_cur1
.endm

.macro libmio_outdez
    .set	use_libmio_outd = 1
    rcall	libmio_outd
.endm

.macro libmio_outhex
    .set	use_libmio_outh = 1
    rcall	libmio_outh
.endm

.macro libmio_clrscr
    rcall	libmio_clr
.endm

.macro libmio_fillchar
    rcall	libmio_fill
.endm

.macro libmio_ramtext
    .set	use_libmio_oram = 1
    rcall	libmio_oram
.endm

.macro libmio_romtext
    .set	use_libmio_orom = 1
    rcall	libmio_orom
.endm

.macro libmio_thistext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    rcall	libmio_othis
.endm

.macro libmio_mtext
    .set	use_libmio_mtext = 1
    rcall	libmio_mtext
.endm

.macro libmio_newline
    .set	use_libmio_newline = 1
    rcall	libmio_newline
.endm

.macro libmio_gotoxy
    .set	use_libmio_gotoxy = 1
    rcall	libmio_gxy
.endm

.macro libmio_plot
    .set	use_libmio_plot = 1
    rcall	libmio_plot
.endm

.macro libmio_box
    .set	use_libmio_plot = 1
    .set	use_libmio_box = 1
    rcall	libmio_box
.endm

.macro libmio_cbox
    .set	use_libmio_cbox = 1
    clt
    rcall	libmio_cbox
.endm

.macro libmio_ibox
    .set	use_libmio_cbox = 1
    set
    rcall	libmio_cbox
.endm

.macro libmio_wbox
    .set	use_libmio_wbox = 1
    rcall	libmio_wbox
.endm

.macro libmio_whbox
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_whbox
.endm

.macro libmio_wh2box
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_wh2box
.endm

.macro libmio_fbox
    .set	use_libmio_plot = 1
    .set	use_libmio_fbox = 1
    rcall	libmio_fbox
.endm

.macro libmio_circle
    .set	use_libmio_circle = 1
    rcall	libmio_circle
.endm

.macro libmio_fcircle
    .set	use_libmio_circle = 1
    rcall	libmio_fcircle
.endm

.macro libmio_draw
    .set	use_libmio_plot = 1
    .set	use_libmio_draw = 1
    rcall	libmio_draw
.endm

.macro libmio_sync
    .set	use_libmio_sync = 1
    rcall	libmio_sync
.endm

.macro libmio_note
    .set	use_libmio_note = 1
    rcall	libmio_note
.endm

.macro libmio_calc
    rcall	libmio_calc
.endm

.macro libmio_ecalc
    rcall	libmio_ecalc
.endm

.macro libmio_pser
    .set	use_libmio_serial = 1
    .set	use_libmio_pser = 1
    rcall	libmio_pser
.endm

.macro libmio_gser
    .set	use_libmio_serial = 1
    .set	use_libmio_gser = 1
    rcall	libmio_gser
.endm

.macro libmio_gserb
    .set	use_libmio_serial = 1
    .set	use_libmio_gser = 1
    rcall	libmio_gserb
.endm

.macro libmio_ppar
    .set	use_libmio_ppar = 1
    rcall	libmio_ppar
.endm

.macro libmio_setcolor
    rcall	libmio_setcol
.endm

.macro libmio_setdrawcolor
    rcall	libmio_setfgc
.endm

.macro libmio_setpalette
    rcall	libmio_setpal
.endm

.macro libmio_setborder
    rcall	libmio_setbrd
.endm

.macro libmio_screenshot
    .set	use_libmio_screenshot = 1
    rcall	libmio_scrs
.endm

.macro libmio_chpump
    .set	use_libmio_chp = 1
    rcall	libmio_chp
.endm

.macro libmio_cconv
    .set	use_libmio_cconv = 1
    rcall	libmio_cconv
.endm

.macro libmio_pconv
    .set	use_libmio_pconv = 1
    rcall	libmio_pconv
.endm

.macro libmio_gchar
    .set	use_libmio_gchar = 1
    rcall	libmio_pconv
.endm

.macro libmio_vcur
    .set	use_libmio_vcur = 1
    rcall	libmio_vcur
.endm

.macro libmio_sprite
    .set	use_libmio_sprites = 1
    rcall	libmio_sprite
.endm

.macro libmio_alert
    rcall	libmio_abox1
.endm

.macro libmio_ask
    rcall	libmio_ynbox1
.endm

.macro libmio_alertthis
    rcall	libmio_abox
.endm

.macro libmio_askthis
    rcall	libmio_ynbox
.endm

.macro libmio_nmode
    .set	use_libmio_dmode = 1
    rcall	libmio_nmode
.endm

.macro libmio_setvmode
    rcall	libmio_svmode
.endm

.macro libmio_random
    .set	use_libmio_psrg = 1
    rcall	libmio_psrg
.endm

.macro libmio_setpal
    .set	use_libmio_setpal = 1
    rcall	libmio_setpal
.endm

.macro libmio_bcopy
    .set	use_libmio_bcopy = 1
    rcall	libmio_bcopy
.endm

.macro libmio_scroll
    .set	use_libmio_scroll = 1
    rcall	libmio_scrl
.endm

.macro libmio_emode
    .set	use_libmio_dmode = 1
    .set	use_libmio_editor_mode = 1
    rcall	libmio_emode
.endm

.macro libmio_menu
    rcall	libmio_dmenu
.endm

.macro libmio_drawmenu
    rcall	libmio_domenu
.endm

.macro libmio_sysconf
    rcall	libmio_setconf
.endm

.macro libmio_sendx
    rcall	libmio_txbl
.endm

.macro libmio_recvx
    rcall	libmio_rxbl
.endm

.macro libmio_clearvector
    rcall	libmio_cvec
.endm

.macro libmio_clearvtext
    rcall	libmio_ctvec
.endm

.macro libmio_setvolume
    rcall	libmio_setvol
.endm

.macro libmio_setmvolume
    rcall	libmio_setvol
.endm

.macro libmio_slow
    rcall	libmio_vidon
.endm

.macro libmio_fast
    rcall	libmio_vidoff
.endm

.macro libmio_channel
    rcall	libmio_setchan
.endm

.macro libmio_startseq
    rcall	libmio_startsq
.endm

.macro libmio_stopseq
    rcall	libmio_stopsq
.endm

.macro libmio_endseq
    rcall	libmio_endsq
.endm

;################################################################################
;#										#
;# libi2c - I2C library for ATMega controllers					#
;# copyright (c) 2007-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU  General Public				#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;#  General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU  General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libi2c_init
    rcall	libi2c_initl
.endm

.macro libi2c_read
    .set	use_libi2c_read = 1
    rcall	libi2c_read
.endm

.macro libi2c_start
    rcall	libi2c_start
.endm

.macro libi2c_stop
    rcall	libi2c_stop
.endm

.macro libi2c_rbyte
    rcall	libi2c_rbyte
.endm

.macro libi2c_rbyten
    rcall	libi2c_rbyten
.endm

.macro libi2c_wbyte
    rcall	libi2c_wbyte
.endm


.macro libi2c_write
    .set	use_libi2c_write = 1
    rcall	libi2c_write
.endm

.macro libi2c_rlm75
    .set	use_libi2c_lm75 = 1
    rcall	libi2c_rlm75
.endm
;################################################################################
;#										#
;# libeep - EEPRO R/W library for AVR controllers				#
;# copyright (c) 2007-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libeep_read
    rcall	libeep_read
.endm

.macro libeep_write
    rcall	libeep_write
.endm

;################################################################################
;#										#
;# libdfl - Dataflash routines							#
;# copyright (c) 2007-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libdfl_format
    rcall	libdfl_format
.endm

.macro libdfl_create
    rcall	libdfl_create
.endm

.macro libdfl_delete
    rcall	libdfl_del
.endm

.macro libdfl_read
    rcall	libdfl_read
.endm

.macro libdfl_nread
    rcall	libdfl_nread
.endm

.macro libdfl_write
    rcall	libdfl_write
.endm

.macro libdfl_free
    rcall	libdfl_cfree
.endm

.macro libdfl_size
    rcall	libdfl_size
.endm

.macro libdfl_maxpage
    rcall	libdfl_maxpage
.endm

.macro libdfl_checkformat
    rcall	libdfl_cif
.endm

.macro libdfl_gettype
    rcall	libdfl_ghead
    rcall	libdfl_gtype
.endm

.macro libdfl_gettype1
    rcall	libdfl_ghead1
    rcall	libdfl_gtype
.endm

.macro libdfl_settype
    rcall	libdfl_stype
.endm

.macro libdfl_gword
    rcall	libdfl_gdword
.endm

.macro libdfl_readraw
    rcall	libdfl_bread
    rcall	libdfl_rdbuf
.endm

.macro libdfl_writeraw
    rcall	libdfl_wrbuf
    rcall	libdfl_bwrite
.endm

